//Original script by CobaltBW, Frostiikin (it is reusable)
//This should be properly self-contained due to Krabs_Reset.lua and the map header check...hopefully.

local debug = 0
addHook("PlayerThink", function(player)
	if mapheaderinfo[gamemap].scalestuff == nil return end
	if player.mo == nil return end
	if not (player.mo and player.mo.scale and player.mo.friction and player.mo.movefactor) return end
	
	local pmo = player.mo
	//Create history
	if player.waterlast == nil
		player.waterlast = false
		player.dashlast = false
		player.realfriction = pmo.friction
		player.lastz = player.mo.z
	end
	local skin = skins[pmo.skin]
	
	//Stat adjust
	if player.charability2 == CA2_SPINDASH
		player.mindash = skin.mindash * 3/2
	end
	local water = 1+(pmo.eflags&MFE_UNDERWATER)/MFE_UNDERWATER //Water factor for momentum halving
	local grounded = P_IsObjectOnGround(pmo)
	local nmom = skin.normalspeed //Skin normalspeed, the integral component
	
	//Dashmode overrides skin normalspeed
	if player.dashmode >= 3*TICRATE
		nmom = player.normalspeed
	end
	
	local scale = pmo.scale //Normalspeed calculations are affected by scale
	local friction = FixedDiv(pmo.friction,pmo.movefactor) //Reversing friction is required for sustaining ground momentum
	local pmom = FixedDiv(FixedHypot(player.rmomx,player.rmomy),scale) //Current speed, scaled for normalspeed calculations
	local pwup = (player.powers[pw_sneakers]) or (player.powers[pw_super]) //Speed-ups multiply max allowed speed by 5/3
	local momangle = R_PointToAngle2(0,0,player.rmomx,player.rmomy) //Used for angling new momentum in ability cases
	//Adjust current speed reading for calculations with pwup status
	if pwup
		pmom = $*3/5
	end
	local mom = FixedHypot(pmo.momx,pmo.momy)

	//General momentum scaling
	
	//Do landing momentum cut
	if pmo.eflags&MFE_JUSTHITFLOOR
		player.normalspeed = skin.normalspeed
		pmo.friction = $-$/10
	
	//Do ground momentum
	elseif grounded
		//The amount of momentum to sustain
		local sustain = FixedDiv(min(pmom*water,nmom*2),friction)
		player.normalspeed = max(nmom,sustain)
	
	//Do air momentum
	elseif not(player.dashmode) //Dashmode overrides normalspeed in the air
		player.normalspeed = skin.normalspeed
	end
	
	//Thok momentum scaling
	if player.charability == CA_THOK
		then
		//Raise thokspeed to current momentum if above innate actionspd
		player.actionspd = max(pmom*water, skin.normalspeed + 5 * FRACUNIT)
	end
	
	//Slope momentum adder
	local momangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
	if player.lastz > player.mo.z and P_IsObjectOnGround(player.mo) and player.mo.state == S_PLAY_ROLL
		P_Thrust(player.mo, momangle, player.speed/80)
	end
	if player.lastz > player.mo.z and P_IsObjectOnGround(player.mo) and player.mo.state != S_PLAY_ROLL
		P_Thrust(player.mo, momangle, player.speed/100)
	end
	if P_IsObjectOnGround(player.mo) and player.mo.state != S_PLAY_ROLL
		if player.speed > player.runspeed
			P_Thrust(player.mo, momangle, player.speed/200)
		end
	end
	--end
	player.lastz = player.mo.z
	
	//Update history
	player.waterlast = (pmo.eflags&MFE_UNDERWATER > 0)
	player.dashlast = (player.pflags&PF_STARTDASH > 0)
	
	//DEBUG//
	if debug
		print("momz " + pmo.momz/FRACUNIT)
		print("actionspd   " + player.actionspd/FRACUNIT)
		print("pmom        " + pmom/FRACUNIT)
		print("normalspeed " + player.normalspeed/FRACUNIT)
	end
end)